
//
//  
//   
//  0    
//  1      
//  2     (  )
//  3     ()
//

flg_ButtonEnabled = 0x00;       //   (default)
flg_ButtonDisabled = 0x01;      //  
flg_CaptionDisabled = 0x00;     //    
flg_CaptionEnabled = 0x02;      //    
flg_CaptionRight = 0x00;        //       (default)
flg_CaptionBottom = 0x04;       //     
flg_ButtonPressed = 0x08;       //  
flg_ButtonInvisible = 0x10;     //  

s_unsel = " unselectable=on ";
//
//  :
//   insertButton(s_name,s_img,s_caption,s_title,s_cmd,w_attrs,w_order,w_width)
//   insertSelect(s_name,s_caption,s_font,s_title,s_cmd,w_attrs,w_width,w_order)
//   insertOption(s_owner_name,s_caption,s_font,s_value)
//   insertSpliter(w_order) 
//   findElement(s_name)
//   getButtonId(s_name)
//   changeButtonStatus(s_name,b_status) 
//   setPressedAttribute(s_name,b_pressed)
//   getButtonAttribute(s_name,s_attr_name)
//   setButtonAttribute(s_name,s_attr_name,s_value)
//   buttonBgColor(s_name,s_color) 
//   modifySelectText(s_name,s_text,s_font)
//   init(b_sort_flag)
//   hide()
//   show(b_sort_flag)
//   inserData(arr_panel_data)

function ControlPanel()
  {
    // 
    this.o_owner = document.body;
    this.path;                                 // default 
    this.css_path          = "css/";           //   CSS- 
    this.imgs_path         = "icons/";         //   
    this.special_imgs_path = "imgs/";          //    
    this.css_file          = "panel.css";      // CSS- 
    this.panel_class       = "panel";          //   
    this.item_class        = "buttons";        //    
    this.item_over_class   = "buttons_over";   //      
    this.item_press_class  = "button_pressed"; //                

    this.width;
    this.disabled_opacity  = 40;   //   
    this.btn_width         = 25;   //  
    this.btn_height        = 24;   //  
    this.btn_hspace        = 0;


    //  
    this.panel_width 	= 0;
    this.initialized 	= 0;
    this.sorted 	= 0;
    this.buttons_cnt 	= 0;
    this.spliters_cnt 	= 0;
    this.display_type	= "inline";

    this.o_panel = document.createElement("SPAN");
    this.o_panel.unselectable = "on";
    this.o_panel.className = this.panel_class;
    this.items = new Array();

    //  correct_paths -     
    this.correct_paths = function ()
      {
        if (typeof(this.path)!="undefined" && this.path!="")
          {
            this.css_path = this.path + this.css_path;
            this.imgs_path = this.path + this.imgs_path;
            this.special_imgs_path = this.path + this.special_imgs_path;
          }
        this.path = "";
      };
    //  insertButton -    
    // :
    //  s_name           
    //  s_img           
    //  s_caption       
    //  s_title          
    //  s_cmd             onClick (javascript)
    //  w_attrs           (  )
    //  w_order              (  )
    //  w_width           (  )
    this.insertButton = function(s_name,s_img,s_caption,s_title,s_cmd,w_attrs,w_order,w_width)
      {
        this.correct_paths();
        var new_item = new Object();
        new_item["id"] = "";
        new_item["name"] = s_name;
        new_item["img"] = this.imgs_path+s_img;
        new_item["caption"] = s_caption;
        new_item["title"] = s_title;
        new_item["cmd"] = s_cmd;
        new_item["attrs"] = w_attrs;
        new_item["width"] = w_width!=undefined?w_width:this.btn_width;
        new_item["hspace"] = this.btn_hspace;
        new_item["type"] = "button";
        if ((w_order==undefined)||(w_order==null))
          w_order = this.items.length;
//        this.items[w_order] = new_item;

        this.items = (new Array).concat(this.items.slice(0,w_order),new_item,this.items.slice(w_order));

        this.panel_width += new_item["width"];
        this.buttons_cnt++;
      };
    //  insertSelect -  SELECT  
    // :
    //  s_name           SELECT
    //  s_caption         SELECT
    //  s_font            
    //  s_title          
    //  s_cmd             onChange (  - javascript:alert('%res%') ). 
    //                   %res% -   OPTIONa
    //                  PS:     : parent.function_name(arg);
    //  w_attrs           (  )
    //  w_width          
    //  w_order              (  )
    this.insertSelect = function(s_name,s_caption,s_font,s_title,s_cmd,w_attrs,w_width,w_order)
      {
        var new_item = new Object;
        new_item["id"] = "";
        new_item["name"] = s_name;
        new_item["caption"] = s_caption;
        new_item["font"] = s_font;
        new_item["title"] = s_title;
        new_item["cmd"] = s_cmd;
        new_item["attrs"] = w_attrs;
        new_item["width"] = w_width;
        new_item["items"] = new Array;
        new_item["type"] = "select";
        if (w_order==undefined)
          w_order = this.items.length;
//        this.items[w_order] = new_item;
        this.items = (new Array).concat(this.items.slice(0,w_order),new_item,this.items.slice(w_order));
        this.panel_width += new_item["width"];
      };
    //  insertOption -  OPTION   SELECT
    // :
    //  s_owner_name     SELECT-
    //  s_caption        OPTION
    //  s_font           
    //  s_value          OPTION
    this.insertOption = function(s_owner_name,s_caption,s_font,s_value)
      {
        var n = this.findElement(s_owner_name);
        if ((n==null)||(this.items[n]["type"]!="select")) return;
        var new_option = new Object;
        new_option["caption"] = s_caption;
        new_option["font"] = s_font;
        new_option["value"] = s_value;
        this.items[n]["items"][this.items[n]["items"].length] = new_option;
      };
    //  insertSpliter -    
    // :
    //   w_order -      (  )
    this.insertSpliter = function(w_order) 
      {
        this.correct_paths();
        var new_item = new Object();
        new_item["type"] = "spliter";
        new_item["img"] = this.special_imgs_path+"spliter.gif";
        if (w_order==undefined)
          w_order = this.items.length;
//        this.items[w_order] = new_item;
        this.items = (new Array).concat(this.items.slice(0,w_order),new_item,this.items.slice(w_order));
        this.panel_width += 4;
        this.spliters_cnt++;
      };
    //  findElement -     
    //      null
    // :
    //   s_name  
    this.findElement = function(s_name)
      {
        var n = null;
        for (var i in this.items)
          if (this.items[i]["name"]==s_name)
            {
              n = i;
              break;
            }
        return n;
      };
    //  getButtonId -  Id  
    // :
    //   s_name  
    this.getButtonId = function(s_name)
      {
        var n = this.findElement(s_name);
        return this.items[n]["id"];
      };
    //  changeButtonStatus -    (/)
    // :
    //   s_name 	 
    //   b_status	 (0 - , 1 - )
    this.changeButtonStatus = function(s_name,b_status) 
      {
        var n = this.findElement(s_name);
        var o_btn;
        if ((n==null)||((o_btn = document.getElementById(this.items[n]["id"]))==null)) return;
        if (b_status)
          {
            var opacity = this.disabled_opacity;
            o_btn.onclick = null;
            o_btn.onmouseout = null;
            o_btn.onmouseover = null;
          }
        else
          {
            var opacity = 100;
            var normal_class = (this.items[n]["attrs"] & flg_ButtonPressed)>0?this.item_press_class:this.item_class;
            o_btn.className = normal_class;
            eval("o_btn.onclick = function() {"+this.items[n]["id"]+".className='"+this.item_press_class+"';"+this.items[n]["cmd"]+";}");
            eval("o_btn.onmouseover = function() {"+this.items[n]["id"]+".className='"+this.item_over_class+"';}");
            eval("o_btn.onmouseout = function() {"+this.items[n]["id"]+".className='"+normal_class+"';}");
          }
        o_btn.style.filter = "alpha(opacity="+opacity+")";
      };
    //  setPressedAttribute -    (/)
    //    s_name         
    //    b_pressed	  (0,1)
    this.setPressedAttribute = function (s_name,b_pressed)
      {
        var n = this.findElement(s_name);
        if ((n==null)||(o_btn = document.getElementById(this.items[n]["id"]))==null) return;
        this.items[n]["attrs"] = b_pressed?this.items[n]["attrs"]|flg_ButtonPressed:this.items[n]["attrs"]&(~flg_ButtonPressed);
        var normal_class = (this.items[n]["attrs"] & flg_ButtonPressed)>0?this.item_press_class:this.item_class;
        o_btn.className = normal_class;
        eval("o_btn.onmouseout = function() {"+this.items[n]["id"]+".className='"+normal_class+"';}");
      };
    //  getButtonAttribute -    
    //  :
    //    s_name         
    //    s_attr_name     (.  insertSelect)
    this.getButtonAttribute = function(s_name,s_attr_name)
      {
        var n = this.findElement(s_name);
        if ((n==null)||(typeof(this.items[n][s_attr_name])=="undefined")) return;
        return this.items[n][s_attr_name];
      }
    //  setButtonAttribute -    
    //  :
    //    s_name         
    //    s_attr_name     (.  insertSelect)
    //    s_value        
    this.setButtonAttribute = function(s_name,s_attr_name,s_value)
      {
        var n = this.findElement(s_name);
        if ((n==null)||(o_btn = document.getElementById(this.items[n]["id"]))==null) return;
        this.items[n][s_attr_name] = s_value;
        var normal_class = (this.items[n]["attrs"] & flg_ButtonPressed)>0?this.item_press_class:this.item_class;
        o_btn.className = normal_class;
        eval("o_btn.onmouseout = function() {"+this.items[n]["id"]+".className='"+normal_class+"';}");
        if (s_attr_name=="cmd")
          eval("o_btn.onclick = function() {"+o_btn.uniqueID+".className='"+this.item_press_class+"';"+this.items[n]["cmd"]+";}");
      };
    //   buttonBgColor -       \
    //   s_color   -    
    //  :
    //    s_name         
    //    s_color          
    this.buttonBgColor = function(s_name,s_color) 
      {
        var n = this.findElement(s_name);
        var o_btn;
        if ((n==null)||(o_btn = document.getElementById(this.items[n]["id"]))==null) return;
        if (s_color==undefined)
          return o_btn.childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[0].style.backgroundColor;
        else
          o_btn.childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[0].style.backgroundColor = s_color;
      };
    //  modifySelectText -    SELECTa
    //  :
    //    s_name         
    //    s_text	 
    //	  s_font	 
    this.modifySelectText = function(s_name,s_text,s_font)
      {
        var n = this.findElement(s_name);
        if ((n==null)||(o_btn = document.getElementById(this.items[n]["id"]))==null) return;
        var item = document.getElementById(o_btn.uniqueID).childNodes[0].childNodes[0].childNodes[0].childNodes[0];
        item.innerHTML = s_text;
        if (s_font!=undefined)
          item.style.fontFamily = s_font;
      };
    //  init -    
    // :
    //   b_sort_flag -     (0  1)
    this.init = function(b_sort_flag)
      {
        document.createStyleSheet(this.css_path+this.css_file); 
        this.correct_paths();
        if (this.initialized==0)
          {
            this.initialized++;
            this.o_owner.appendChild(this.o_panel);
          }
        var o_panel = this;
        while (this.o_panel.children(0)!=null)  
          this.o_panel.removeChild(this.o_panel.children(0));
        if (b_sort_flag && this.sorted==0)
          {
            this.items.sort();
            this.sorted++;
          }
        for (var i in this.items)
          if (this.items[i]["type"]=="spliter")
            {
              var o_spliter = document.createElement("SPAN");
              o_spliter.className = "spliter";
              o_spliter.innerHTML = "<IMG src="+this.items[i]["img"]+" align=bottom hspace=1 width=4 height="+(this.btn_height-6)+">";
              this.o_panel.appendChild(o_spliter);
            }
          else
            {
              var o_btn = document.createElement("SPAN");
              o_btn.unselectable = "on";
              o_btn.style.width = this.items[i]["width"];
              o_btn.style.height = this.btn_height-1;
              o_btn.title = this.items[i]["title"];
              this.items[i]["id"] = o_btn.uniqueID;
              var normal_class = (this.items[i]["attrs"] & flg_ButtonPressed)>0?this.item_press_class:this.item_class;
              o_btn.className = normal_class;
              if ((this.items[i]["attrs"] & flg_ButtonDisabled)>0)
                o_btn.style.filter = "alpha(opacity="+this.disabled_opacity+")";
              else
                {
                  eval("o_btn.onmouseover = function() {"+o_btn.uniqueID+".className='"+this.item_over_class+"';}");
                  eval("o_btn.onmouseout = function() {"+o_btn.uniqueID+".className='"+normal_class+"';}");
                }
              switch (this.items[i]["type"]) {
                case "button":
                  if ((this.items[i]["attrs"] & flg_ButtonDisabled)==0)
                    eval("o_btn.onclick = function() {"+o_btn.uniqueID+".className='"+this.item_press_class+"';"+this.items[i]["cmd"]+";}");
                  var HTML = "<TABLE cellspacing=0 cellpadding=0"+s_unsel+
                    "height="+(this.btn_height-4)+" width="+(this.btn_width-3)+">"+
                    "<TR"+s_unsel+"><TD align=center"+s_unsel+" nowrap>"+
                    "<IMG"+s_unsel+"src='"+this.items[i]["img"]+"' hspace="+this.items[i]["hspace"];
                  if ((this.items[i]["attrs"] & flg_CaptionEnabled)>0)
                    {
                      if ((this.items[i]["attrs"] & flg_CaptionBottom)>0)
                        HTML += " vspace=2><BR";
                      HTML += ">"+this.items[i]["caption"];
                    }
                  HTML += "</TD></TABLE>";
                  break;
                case "select":
                  o_popup = window.createPopup();
                  o_popup.document.createStyleSheet(this.css_path+this.css_file);
                  var HTML = "<DIV class=popup"+s_unsel+">";
                  for (var j in this.items[i]["items"])
                    {
                      var cmd = this.items[i]["cmd"].replace(/'/g,"\\'");
                      cmd = cmd.replace("%res%",this.items[i]["items"][j]["value"]);
                      HTML += "<DIV"+s_unsel;
                      if (this.items[i]["items"][j]["font"]!="")
                        HTML += "style=\"font-family:"+this.items[i]["items"][j]["font"]+"\" ";
                      HTML += "onMouseOver=\"this.style.backgroundColor=\\'#000080\\';this.style.color=\\'white\\';\" "+
                        "onMouseOut=\"this.style.backgroundColor=\\'\\';this.style.color=\\'\\';\" "+
                        "onClick=\"obj=parent."+o_btn.uniqueID+".childNodes[0].childNodes[0].childNodes[0].childNodes[0];"+
                        "obj.style.fontFamily=this.style.fontFamily;obj.innerText=this.innerText;parent.o_popup.hide();"+
                        cmd+"\">";
                      HTML += this.items[i]["items"][j]["caption"]+"</DIV>";
                    }
                  HTML += "</DIV>";
                  var handle = "o_popup.document.body.innerHTML='"+HTML+"';o_popup.show(1,"+(this.btn_height-1)+","+this.items[i]["width"]+",135,"+o_btn.uniqueID+");";
                  eval("o_btn.onclick = function(){"+handle+"}");

                  HTML = "<TABLE cellspacing=0 cellpadding=0 height=100%"+s_unsel+"><TR"+s_unsel+">";
                  HTML += "<TD"+s_unsel+"class=select_txt style='width:"+(this.items[i]["width"]-13)+";font-family:"+this.items[i]["font"]+";'>"+this.items[i]["caption"]+"</TD>";
                  HTML += "<TD"+s_unsel+"class=select_arr><IMG"+s_unsel+"src='"+this.special_imgs_path+"arrow.gif'></TD>";
                  HTML += "</TR></TABLE>";
                  o_btn.style.height = this.btn_height-1;
                  break;
              }
              o_btn.innerHTML = HTML;
              this.o_panel.appendChild(o_btn);
            }
        this.o_panel.style.width = this.width==undefined?this.panel_width+4+this.spliters_cnt*2:this.width;
        this.o_panel.style.display = this.display_type;
      };
    //  hide -  
    this.hide = function () 
      {
        this.o_panel.style.display = "none";
      };
    //  show -  
    // :
    //   b_sort_flag -     (0  1)
    this.show = function (b_sort_flag) 
      {
        if (this.initialized==0)
          this.init(b_sort_flag);
        this.o_panel.style.display = this.display_type;
      };
    //  inserData -        
    // :
    //   arr_panel_data -   
    //     var panel_data = [
    //       [( ),     ],
    //       [], - 
    //     ];
    //    : button, select, option
    // PS:   button  s_caption  
    this.inserData = function (arr_panel_data)
      {
        this.correct_paths();
        for (var i in arr_panel_data)
          {
            var str = "";
            if (arr_panel_data[i].length)
              {
                for (var j=1;j<arr_panel_data[i].length;j++)
                  {
                    str += (typeof(arr_panel_data[i][j])=="string"?'"'+arr_panel_data[i][j]+'"':arr_panel_data[i][j])+',';
                    if (j==2 && (arr_panel_data[i][0]=="button")) str += '"",';
                  }
                str = str.substr(0,str.length-1);
                switch (arr_panel_data[i][0]) {
                  case "button":
                    eval("this.insertButton("+str+");");
                    break;
                  case "select":
                    eval("this.insertSelect("+str+");");
                    break;
                  case "option":
                    eval("this.insertOption("+str+");");
                    break;
                }
              }
            else
              {this.insertSpliter();}
          }
      };
    //  setVisibilityAttr -  \  
    // :
    //   name	  
    //   state	 (0-   1-)
    this.setVisibilityAttr = function(s_name,b_state)
      {
        var n = this.findElement(s_name);
        if ((n==null)||(o_btn = document.getElementById(this.items[n]["id"]))==null) return;
        var obj = document.getElementById(this.items[n]["id"]);
        if (b_state)
          {
            if (obj.style.display=="none")
              this.o_panel.style.width = (this.o_panel.style.width).replace("px","")/1 + this.items[n]["width"];
            obj.style.display = "";
            this.items[n]["attrs"] |= flg_ButtonInvisible;
          }
        else
          {
            if (obj.style.display=="")
              this.o_panel.style.width = (this.o_panel.style.width).replace("px","")/1 - this.items[n]["width"];
            obj.style.display = "none";
            this.items[n]["attrs"] = this.items[n]["attrs"]&(~flg_ButtonPressed);
          }
      }
  }
